// Mircea Digulescu - Bucuresti, ROMANIA

#include <fstream.h>
#include <string.h>
#include <ctype.h>

extern unsigned _hplen = 0;

ifstream in("exp.in");
ofstream out("exp.out");

class node
 {
 public:
  char s[62];
  node *next;
  node() {next=NULL;}
  ~node() {if(next) delete next;next=NULL;}
 };

class Lista
 {
  public:
  node *first;
  node *last;

  void Add(char *s)
   {
    node *n = new node;
    strcpy(n->s,s);
    n->next=first;
    first=n;
    if(!last) last=first;
   }
  void Clear() {if(first) delete first;}
 };

char st_op[300];
int lop;
Lista *st_rez[300];
int lrez;

#define PushOp(c) (st_op[lop++]=(c))
#define PopOp() (st_op[--lop])
#define PushRez(l) (st_rez[lrez++]=(l))
#define PopRez() (st_rez[--lrez])

void Eval(char seek=0)
 {
  Lista *aa, *bb;
  node *a, *b;
  char s[60],c;
  Lista *r;
  do
   {
    c = PopOp();
    switch(c)
     {
      case '+':
       aa = PopRez();
       bb = PopRez();
       r = new Lista;
       r->first=aa->first;
       r->last=aa->last;
       r->last->next=bb->first;
       r->last=bb->last;
       delete aa;
       delete bb;
       PushRez(r); break;
      case '*':
       aa = PopRez();
       bb = PopRez();
       a=aa->first;
       b=bb->first;
       r = new Lista;
       r->first=r->last=NULL;
       while(a)
	{
	b=bb->first;
	 while(b)
	  {
	   strcpy(s,a->s);
	   strcat(s,b->s);
	   r->Add(s);
	   b=b->next;
	  }
	 a=a->next;
	}
       aa->Clear();
       bb->Clear();
       delete aa;
       delete bb;
       PushRez(r);
      case '(': break;
     }
   } while (seek && c!='(');
 }

int pri[256];

void SSort(char *s, char *r)
 {
 int l = strlen(s);
  int c[256];
  for(int i=0;i<256;i++) c[i]=0;
  for(i=0;i<l;i++) c[s[i]]++;
  for(i=1;i<256;i++) c[i]+=c[i-1];
  for(i=l-1;i>=0;i--)
	r[--c[s[i]]]=s[i];
  r[l]=0;
 }

char str[255][100];
int hp[255];
int hpl;

#define LEFT(i) (2*(i)+1)
#define RIGHT(i) (2*(i)+2)

void Heapify(int i)
 {
  int max=i;
  while(1)
   {
    if(LEFT(i)<hpl) if( strcmp(str[hp[LEFT(i)]],str[hp[max]]) >0) max=LEFT(i);
    if(RIGHT(i)<hpl) if( strcmp(str[hp[RIGHT(i)]],str[hp[max]]) >0) max=RIGHT(i);
    if(max==i) break;
    int t=hp[i];
    hp[i]=hp[max];
    hp[max]=t;
    i=max;
   }
 }

void HSort()
 {
  for(int i=0;i<hpl;i++) hp[i]=i;
  for(i=hpl/2;i>=0;i--) Heapify(i);
  while(hpl)
   {
   hpl--;
    int t=hp[0];
    hp[0]=hp[hpl];
    hp[hpl]=t;
    Heapify(0);
   }
 }

void main()
 {
 unsigned char c;
 pri['+']=1;
 pri['*']=2;
 pri['(']=pri[')']=0;
 char s[3];
 PushOp('(');
 while(c)
  {
   in.get(c);
   if(c==')') {Eval(1);continue;}
   if(c=='(') {PushOp(c);continue;}
   if(c=='*' || c=='+')
    {
     while(pri[st_op[lop-1]] >= pri[c]) Eval();
     PushOp(c);
     continue;
    }
   if(!isalpha(c)) break;
   s[0]=c;s[1]=0;
   Lista *r = new Lista;
   r->first=r->last=NULL;
   r->Add(s);
   PushRez(r);
  }
  Eval(1);
  Lista *R = PopRez();
  node *t=R->first;
  while(t)
   {
    SSort(t->s,str[hpl++]);
    t=t->next;
   }
  R->Clear();
  int n=hpl;
  HSort();
  for(int i=0;i<n;i++)
   {
    char *s=str[hp[i]];
    while(*s) {out<<*s;if(*(s+1)) out<<"*";s++;}
    if(i+1<n) out<<"+";
   }
 }